        

PORTA   EQU $00    ; Puerto desde el que activan los motores
PORTE   EQU $0A    ; Puerto E donde se lee los sensores de obtaculos
TCTL2   EQU $21    ;
TMSK1   EQU $22    ;
TFLG1   EQU $23    ; Flags de los temporizadores
TCNT    EQU $0E    ; Lleva la cuenta actual del temporizador
TOC1    EQU $16    ; Registro que almacena el tiempo final
PVIC3   EQU $00E2  ; Dirreccin de interrupcin de capturador
PORTD   EQU $08    ; Direccin del puerto D
DDRD    EQU $09    ; Registro de configuracin del puerto D


        ORG $0000  ; Direccin de origen para las variables

pasos_d RMB 2      ; Variable para contar los paso de encoder
pasos_l RMB 2      ; Variable para contar los pasos de que se va adalante
        ORG $B600  ; Direccin de la memoria eeprom
 
inic    LDAA #$7E     ; Inicializacin del vector de interrupccin de la eeprom
        STAA PVIC3
        LDX #h_enc_d
        STX PVIC3+1
        LDD #$00      ; Inicializacin de la variables para contor pasos
        STD pasos_d
        LDX #$1000
        BCLR DDRD,X $00   ; Configuracin del puerto D como entradas
inicte  BCLR TCTL2,X $03  ; Configurar el capturador 3 con flancos de subida y bajada
        BSET TCTL2,X $03
        BSET TMSK1,X $01  ; Activar las interrupciones del capt. 3
        CLI               ; Activar las interrupciones
        BRA test          ; Ir a la subrutina bucle principal
temp    LDD TCNT,X                  ; Temporizacin de 10 ms.
        ADDD #20000
        STD TOC1,X                  ; Carga TOC1 con cuenta final (10 ms)
loop1   BRCLR TFLG1,X $80 loop1     ; Esperamos a que pasen 10 ms
        BCLR TFLG1,X $7F            ; Desactivamos OC1F para siguiente cuenta
        RTS
limpiar LDD #$0000      ; Limpiamos la variable pasos_d
        STD pasos_d     
        RTS
limp    LDD #$0000      ; Limpiar la variable pasos_l
        STD pasos_l
        RTS
esperar JSR limpiar     ; Esta subrutina espera a que se den dos paso de encoder
esp     LDD pasos_d
        CPD #2
        BNE esp
        RTS
esper   JSR limpiar     ; Esta subrutina espa a que se den 4 paso de encoder
es5     LDD pasos_d
        CPD #4
        BNE es5
        RTS
esper1  JSR limpiar     ; Esta subrutina espera a que se sidn 8 paso de encoder
r       LDD pasos_d
        CPD #8
        BNE r
        RTS
test    JSR limpiar     ; Bucle princial
te      BRCLR PORTE,X $02 bumpd1    ; Se salta a bumpd1 si se choca el bump. derecho
        BRCLR PORTE,X $01 bumpi1    ; Se salta a bumpi1 si se choca el bump.izqui    
        BRCLR PORTE,X $08 sensoi1   ; Salta si se activa el sensor analog izqui
        BRCLR PORTE,X $20 sensod1   ; Salta si se activa el sensor analog dere
        BRCLR PORTD,X $04  g_dere1            ;El sensor dig de la derecha
        BRCLR PORTD,X $08  g_izqui1           ;El sensor dig de la izquierda
        BRCLR PORTD,X $10 avanza              ;El sensor dig de adelante slo
        LDAA #$78                   ; Robot va hacia delante  48 pasos               
        STAA PORTA,X
        LDD pasos_d
        CPD #48
        BNE te
te1     BRCLR PORTE,X $02 bumpd1     ; Salta si se activa el bump.derech
        BRCLR PORTE,X $01 bumpi1     ; Salta si se activa el bump.izquier
        BRCLR PORTE,X $08 sensoi1    ; Salta si se activa el sensor analog izqu
        BRCLR PORTE,X $20 sensod1    ; Salta si se activa el sensor anolog dere
        BRCLR PORTD,X $04  g_dere1            ;El sensor dig de la derecha
        BRCLR PORTD,X $08  g_izqui1           ;El sensor dig de la izquierda
        BRCLR PORTD,X $10 avanza             ;El sensor dig de adelante slo
        LDAA #$38                   ; Robot gira a la derecha 8 pasos de encoder                 
        STAA PORTA,X
        JSR esper1
        JMP test    ; Si no ha activado ningn sensor se hace otra vez el recorrido
sensoi1 BRA sensoi  ; Salto a sus correspondientes etiquetas
g_dere1 BRA g_dere
g_izqui1 BRA g_izqui
sensod1 BRA sensod
bumpd1  BRA bumpd
bumpi1  BRA bumpi
avanza  LDAA #$38           ;Cuando me detecta con el sensor dig de adelante        
        STAA PORTA,X        ;El robot da una vuelta de 180 y voy 4 paso adelane
        JSR limpiar
u       LDD pasos_d
        BRCLR PORTE,X $08 sensoi1
        CPD #30
        BNE u
        LDAA #$78
        STAA PORTA,X
        BRCLR PORTE,X $08 sensoi1
        BRCLR PORTE,X $20 sensod1
        JSR esper
        JMP test              ; Volvemos al bucle principal
g_dere  LDAA #$58             ; Cuando me detecta el sensor dig izquierdo
        STAA PORTA,X
        BRCLR PORTE,X $20 sensod1 ; Miro el sensor analo dere si ha un obstac
        JSR esperar
        JMP test
g_izqui LDAA #$38             ; Cuando me detecta el sensor dig derech
        STAA PORTA,X
        BRCLR PORTE,X $08 sensoi1  ; Miro el sensor analo izqui si hay un obsta
        JSR esperar
        JMP test
sensoi  LDAA #$58              ; Si he encotrado un obstac a mi derech al girar
        STAA PORTA,X
        BSR tem
        JMP test
tem     JSR esper1             ; Voy hacia adelante un tiempo fijo
        LDAA #$78
        STAA PORTA,X
        JSR esperar
        RTS
sensod  LDAA #$38           ; Si he encontrador un obstac a mi izqu al girar
        STAA PORTA,X
        BSR tem
        JMP test
bumpd   JSR atras           ; Cuando detecto con el bump derecho, voy atras
        BSR izqui           ; Voy al bucle izqui a buscar el obstac
        JMP frented         ; Voy al bucle frente derecha
bumpi   JSR atras           ; Cuando detecto con el bump izqui, voy atras 
        BSR dere            ; Voy al bucle frente izqui
        JMP frentei  
izqui   LDAA #$38           ; Giro al derecha un tiempo fijo
        STAA PORTA,X
        LDY #30
h1      JSR temp
        DEY
        BNE h1
        RTS
dere    LDAA #$58           ; Giro a la izquierda un tiempo fijo
        STAA PORTA,X
        LDY #30
h       JSR temp
        DEY
        BNE h
        RTS
frented LDAA #$78           ; Voy recto durante tres pasos de encoder 
        STAA PORTA,X        ; o si antes ha dectectado el bump. derecho o
        JSR limpiar
gh      LDD pasos_d          ; el sensor de la derecha
        BRCLR PORTE,X $02 bumpd2
        BRCLR PORTE,X $20 de
        CPD #2
        BNE gh
        JMP test
bumpd2  JMP bumpd
bumpi2  JMP bumpi
frentei LDAA #$78            ; Voy recto durante tres pasos de encoder
        STAA PORTA,X         ; o si antes ha detectado el bump. izquierdo o
        JSR limpiar          ; el sensor de la izquierda
gh1     LDD pasos_d
        BRCLR PORTE,X $01 bumpi2
        BRCLR PORTE,X $08 iz
        CPD #2
        BNE gh1
        JMP test
iz      JSR limp
vol     BRCLR PORTE,X $01 bumpi2    ;  Voy recto hasta que deje de detectar
        BRCLR PORTE,X $08 jk        ; el sensor analo. izquir o se compla un
        BRA lg                      ; numero de pasos determinados
jk      LDD pasos_l
        CPD #78
        BNE vol
lg      BRA car
car     JSR limpiar
ca      LDD pasos_d                  ; Voy recto un nmero determinado
        BRCLR PORTE,X $02 bumpd2     ; de pasos para no chocar con el 
        BRCLR PORTE,X $01 bumpi2     ; obstculo
        CPD #12
        BNE ca
        JMP inicte
de      JSR limp
vol1    BRCLR PORTE,X $02 bumpd2     ; Voy recto hasta que deje de detectar
        BRCLR PORTE,X $20 jk1        ; el sensor analo. derecha o se cumpla un
        BRA lg1                      ; nmero 78 pasos
jk1     LDD pasos_l
        CPD #78
        BNE vol1
lg1     BRA car
atras   LDAA #$18                ; Voy atras un tiempo fijo de los encoder
        STAA PORTA,X
        JSR limpiar
x       LDD pasos_d
        CPD #2
        BNE x
        RTS
h_enc_d LDD pasos_d              ; Rutinas de interrupcin que lo que hace
        ADDD #$01                ; es sumar uno a las variables de los 
        STD pasos_d              ; encoder
        LDD pasos_l
        ADDD #$01
        STD pasos_l
        LDAA #$01                ; Desactivo el flag de interrupciones del
        STAA TFLG1,X             ; encoder 
        RTI     
fin     END
