/*
 ͻ
  SPI.H     (C) GRUPO J&J. ABRIL 1997                                    
 ͹
   Rutinas de manejo del SPI mediante espera activa.                     
                                                                         
   spi(c) --> Funcin que realizar un 'intercambio' por el SPI. Enva    
              El carcter c y devuelve lo que se reciba por el SPI.      
   spi_maestro() -> Macro para configurar el SPI en modo maestro.        
   spi_esclavo() -> Macro para configurar el SPI en modo esclavo         
                                                                         
 ͼ */
#include "REGS6811.H"

/*                   Ŀ
 ĳ Macros para configurar el SPI 
                                           */
#define spi_maestro() DDRD=0x38; SPCR=0x54; PORTD=0x00
#define spi_esclavo() DDRD=0x04; SPCR=0x44

char spi(char c)
/* Ŀ
    Esta funcin realizar un 'intercambio' de informacin  
    por el SPI: Se enva el carcter indicado y se devuel- 
    ve lo que venga por el SPI.                            
    */
{
  asm ("         PSHY");
  asm ("         LDY #$1029");
  asm ("         LDAA %c");
  asm ("         STAA 1,Y");
  asm ("wspi     BRCLR 0,Y $80 wspi");
  asm ("         LDAB 1,Y");
  asm ("         PULY");
}

